function [lambda,x,iter]=eigpower(A,tol,nmax,x0)
%EIGPOWER Evalue numriquement une valeur propre
% d'une matrice
% LAMBDA=EIGPOWER(A) calcule avec la mthode de la
% puissance la valeur propre de A de module maximal
%  partir d'une donne initial qui par dfaut est
% le vecteur constitu de 1
% LAMBDA=EIGPOWER(A,TOL,NMAX,X0) utilise la tolrance
% TOL pour l'erreur absolue (1.e-6 par dfaut), un
% nombre maximal d'itrations NMAX (100 par dfaut),
% et dmarre d'un vecteur initial X0.
% [LAMBDA,V,ITER]=EIGPOWER(A,TOL,NMAX,X0) retourne
% aussi le vecteur propre V tel que A*V=LAMBDA*V et le
% numro de l'itration  laquelle V a t calcul.
[n,m] = size(A);
if n ~= m, error('Matrices carres seulement'); end
if nargin == 1
   tol = 1.e-06;   x0 = ones(n,1);   nmax = 100;
end
x0 = x0/norm(x0);
pro = A*x0;
lambda = x0'*pro;
err = tol*abs(lambda) + 1;
iter = 0;
while err>tol*abs(lambda) & abs(lambda)~=0 & iter<=nmax
   x = pro;              x = x/norm(x);
   pro = A*x;            lambdanew = x'*pro;
   err = abs(lambdanew - lambda);
   lambda = lambdanew;   iter = iter + 1;
end
return
