function [x, iter]= itermeth(A,b,x0,nmax,tol,P)
%ITERMETH    Mthode itrative gnrale
% X = ITERMETH(A,B,X0,NMAX,TOL,P) tente de rsoudre le
% systme d'quations linaires A*X=B d'inconnue X.
% La matrice A, de taille NxN, doit etre inversible et
% le second membre B doit tre de longueur N.
% P='J' slectionne la methode de Jacobi, P='G' celle
% de Gauss-Seidel. Autrement, P  est une matrice N x N
% qui joue le rle de prconditionneur dans la methode
% de Richardson dynamique.
% Les itrations s'arrtent quand le rapport entre la
% norme du k-me residu et celle du rsidu initial est
% infrieure ou gale  TOL, le nombre d'itrations
% effectues est alors renvoy dans ITER.
% NMAX est le nombre maximum d'itrations. Si P
% n'est pas dfini, c'est la mthode du Gradient 
% pas optimal qui est utilise
[n,n]=size(A);
if nargin == 6
 if ischar(P)==1
  if P=='J'
   L=diag(diag(A)); U=eye(n);
   beta=1; alpha=1;
  elseif P == 'G'
   L=tril(A); U=eye(n);
   beta=1; alpha=1;
  end
 else
     [L,U]=lu(P);
     beta = 0;
 end
else
  L = eye(n); U = L;
  beta = 0;
end
iter = 0;
x = x0;
r = b - A * x0;
r0 = norm(r);
err = norm (r);
while err > tol & iter < nmax
  iter = iter + 1;
  z = L\r;  z = U\z;
  if beta == 0
     alpha = z'*r/(z'*A*z);
  end
  x = x + alpha*z;
  r = b - A * x;
  err = norm (r) / r0;
end
return
